routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', ['as' => 'home', 'uses' => 'PagesController@home'])->middleware('example');

/*Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');*/

DB::listen(function($query) {
	echo "<pre>{$query->sql}-{$query->time}</pre>";
});

Route::get('/', ['as' => 'home', 'uses' => 'PagesController@home']);

Route::get('saludos/{nombre?}', ['as' => 'saludos', 'uses' => 'PagesController@saludo'])->where('nombre', "[A-Za-z]+");

Route::resource('mensajes', 'MessagesController');
Route::resource('usuarios', 'UsersController');
Route::get('roles', function() {
	return \App\Role::with('user')->get();
});

Route::get('login', ['as' => 'login', 'uses' => 'Auth\LoginController@showLoginForm']);
Route::post('login', 'Auth\LoginController@login');
Route::get('logout', 'Auth\LoginController@logout');

/*Route::get('test', function() {
	$user = new App\User;
	$user->name = 'Jesus Roncal';
	$user->email = 'jesusroncal94@gmail.com';
	$user->password = bcrypt('123123');
	$user->save();

	return $user;
});


//Route::get('contactos', ['as' => 'contactos', 'uses' => 'PagesController@contact']);

//Route::post('contacto', 'PagesController@mensajes');

/*Route::get('mensajes', ['as' => 'messages.index', 'uses' => 'MessagesController@index']);
Route::get('mensajes/create', ['as' => 'messages.create', 'uses' => 'MessagesController@create']);
Route::post('mensajes', ['as' => 'messages.store', 'uses' => 'MessagesController@store']);
Route::get('mensajes/{id}', ['as' => 'messages.show', 'uses' => 'MessagesController@show']);
Route::get('mensajes/{id}/edit', ['as' => 'messages.edit', 'uses' => 'MessagesController@edit']);
Route::put('mensajes/{id}', ['as' => 'messages.update', 'uses' => 'MessagesController@update']);
Route::delete('mensajes/{id}', ['as' => 'messages.destroy', 'uses' => 'MessagesController@destroy']);*/

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function setPasswordAttribute($password)
    {
        $this->attributes['password'] = bcrypt($password);
    }

    public function roles()
    {
        //return $this->belongsTo(Role::class);
        return $this->belongsToMany(Role::class, 'assigned_roles')->withTimestamps();
    }

    public function hasRoles(array $roles)
    {
        /*foreach ($roles as $role)
        {
            foreach ($this->roles as $userRole)
            {
                if($userRole->name === $role)
                {
                    return true;
                }
            }
        }

        return false;*/

        return $this->roles->pluck('name')->intersect($roles)->count();
    }

    public function isAdmin()
    {
        return $this->hasRoles(['admin']);
    }

    public function note()
    {
        return $this->morphOne(Note::class, 'notable');
    }

    public function tags()
    {
        return $this->morphToMany(Tag::class, 'taggable')->withTimestamps();
    }
}

app/Http/Controllers/UsersController.php
<?php

namespace App\Http\Controllers;

use App\User;
use App\Role;
use App\Note;
use App\Tag;
use App\Taggable;
use DB;
use App\Http\Requests\CreateUserRequest;
use Illuminate\Http\Request;
use App\Http\Requests\UpdateUserRequest;

class UsersController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth', ['except' => ['show']]);
        $this->middleware('roles:admin', ['except' => ['edit', 'update', 'show']]);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $users = User::with(['roles' ,'note', 'tags'])->get();

        return view('users.index', compact('users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $roles = Role::pluck('display_name', 'id');

        return view('users.create', compact('roles'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  App\Http\Requests\CreateUserRequest
     * @return \Illuminate\Http\Response
     */
    public function store(CreateUserRequest $request)
    {
        $user = User::create($request->all());
        $user->roles()->attach($request->roles);

        return redirect()->route('usuarios.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $user = User::findOrFail($id);

        return view('users.show', compact('user'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $user = User::findOrFail($id);
        $this->authorize('edit', $user);
        $roles = Role::pluck('display_name', 'id');
        $tags = Tag::pluck('name', 'id');

        //dd($user->id);

        return view('users.edit', compact('user', 'roles', 'tags'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateUserRequest $request, $id)
    {
        try {
            DB::beginTransaction();
                $user = User::with('note', 'tags')->findOrFail($id);
                $this->authorize('update', $user);
                
                (
                    Note::whereHasMorph('notable', [User::class], function($query) use($user)
                    {
                        $query->where('notable_id', isset($user->note->notable_id) ? $user->note->notable_id : 0);
                    })->count()
                )
                ?
                    $user->note()->update(['body' => $request->note])
                :
                    $user->note()->create(['body' => $request->note]);

                $user->update($request->only('name', 'email'));
                $user->roles()->sync($request->roles);
                $user->tags()->sync($request->tags);
            DB::commit();
        } catch (Exception $e) {
            DB::rollback();
        }

        return back()->with('info', 'Usuario actualizado');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $user = User::findOrFail($id);
        $this->authorize('destroy', $user);
        $user->delete();

        return back();
    }
}

resources/views/users/create.blade.php
@extends('layout')


@section('contenido')

	<h1>Crear nuevo usuario</h1>

	<form method="POST" action="{{ route('usuarios.store') }}">
		@include('users.form', ['user' => new App\User])
		<input class="btn btn-primary" type="submit" value="Guardar">
	</form>

@stop

resources/views/users/edit.blade.php
@extends('layout')

@section('contenido')

<h1>Editar usuario</h1>

@if(session()->has('info'))
	<div class="alert alert-success">
		{{ session('info') }}
	</div>
@endif

<form method="POST" action="{{ route('usuarios.update', $user->id) }}">
	{!! method_field('PUT') !!}
	
	@include('users.form')

	<input class="btn btn-primary" type="submit" value="Enviar">
</form>

@stop

resources/views/users/form.blade.php
<input type="hidden" name="_token" value="{{ csrf_token() }}">
{!! csrf_field() !!}


<p><label for="name">
	Name
	<input class="form-control" type="text" name="name" value="{{ isset($user->name) ? $user->name : old('name') }}">
	{!! $errors->first('name', '<div class="alert alert-danger" role="alert">:message</div>') !!}
</label></p>

<p><label for="email">
	Email
	<input class="form-control" type="email" name="email" value="{{ isset($user->email) ? $user->email : old('email') }}">
	{!! $errors->first('email', '<div class="alert alert-danger" role="alert">:message</div>') !!}
</label></p>


@unless($user->id)
	<p><label for="password">
		Password
		<input class="form-control" type="password" name="password">
		{!! $errors->first('password', '<div class="alert alert-danger" role="alert">:message</div>') !!}
	</label></p>

	<p><label for="password_confirmation">
		Password Confirm
		<input class="form-control" type="password" name="password_confirmation">
		{!! $errors->first('password_confirmation', '<div class="alert alert-danger" role="alert">:message</div>') !!}
	</label></p>
@endunless


<div class="checkbox">
	@foreach($roles as $id => $display_name)
		<label for="roles">
			<input
				type="checkbox"
				value="{{ $id }}"
				{{ $user->roles->pluck('id')->contains($id) ? 'checked' : ''}}
				name="roles[]">
			{{ $display_name }}
		</label>
	@endforeach
</div>
{!! $errors->first('roles', '<div class="alert alert-danger" role="alert">:message</div>') !!}

<p><label for="note">
	Nota
	<input class="form-control" type="text" name="note" value="{{ isset($user->note->body) ? $user->note->body : old('note') }}">
</label></p>

<div class="checkbox">
	@foreach($tags as $id => $name)
		<label for="tags">
			<input
				type="checkbox"
				value="{{ $id }}"
				{{ $user->tags->pluck('id')->contains($id) ? 'checked' : ''}}
				name="tags[]">
			{{ $name }}
		</label>
	@endforeach
</div>
{!! $errors->first('tags', '<div class="alert alert-danger" role="alert">:message</div>') !!}

resources/views/users/index.blade.php
@extends('layout')

@section('contenido')

<h1>Todos los usuarios</h1>

<a href="{{ route('usuarios.create') }}" class="btn btn-primary float-right">Crear nuevo usuario</a>

<table width="100%" class="table">
	<thead>
		<tr>
			<th>ID</th>
			<th>Nombre</th>
			<th>Email</th>
			<th>Roles</th>
			<th>Notas</th>
			<th>Etiquetas</th>
			<th>Acciones</th>
		</tr>
	</thead>
	<tbody>
		@foreach($users as $user)
			<tr>
				<td>{{ $user->id }}</td>
				<td>
					<a href="{{ route('usuarios.show', $user->id) }}">{{ $user->name }}</a>
				</td>
				<td>{{ $user->email }}</td>
				<td>
					{{ $user->roles->pluck('display_name')->implode(' - ') }}
					{{--@foreach($user->roles as $role)
						<span class="badge badge-pill badge-dark">
						{{ $role->display_name }}
					</span>
					@endforeach--}}
				</td>
				<td>{{ isset($user->note->body) ? $user->note->body : '' }}</td>
				<td>{{ isset($user->tags) ? $user->tags->pluck('name')->implode(', ') : ''}}</td>
				<td>
					<a class="btn btn-primary btn-sm" href="{{ route('usuarios.edit', $user->id) }}">Editar</a>
					<form style="display: inline;" method="POST" action="{{ route('usuarios.destroy', $user->id) }}">
						{!! method_field('DELETE') !!}
						{!! csrf_field() !!}

						<button class="btn btn-danger btn-sm" type="submit">Eliminar</button>
					</form>
				</td>
			</tr>
		@endforeach
	</tbody>
</table>

@stop

resources/views/users/show.blade.php
@extends('layout')

@section('contenido')

<h1>{{ $user->name }}</h1>

<table class="table">
	<tr>
		<th>Nombre: </th>
		<th>{{ $user->name }}</th>
	</tr>
	<tr>
		<th>Email: </th>
		<th>{{ $user->email }}</th>
	</tr>
	<tr>
		<th>Roles: </th>
		<td>
			<ul>
				@foreach($user->roles as $role)
					<li>{{ $role->display_name }}</li>
				@endforeach
			</ul>
		</td>
	</tr>
</table>

@can('edit', $user)
	<a href="{{ route('usuarios.edit', $user->id) }}" class="btn btn-info">Editar</a>
@endcan

@can('destroy', $user)
	<form style="display: inline;" method="POST" action="{{ route('usuarios.destroy', $user->id) }}">
		{!! method_field('DELETE') !!}
		{!! csrf_field() !!}

		<button class="btn btn-danger" type="submit">Eliminar</button>
	</form>
@endcan

@stop